package org.libraw;
import java.util.Collections;
import java.util.Iterator;
import org.bridj.BridJ;
import org.bridj.Callback;
import org.bridj.FlagSet;
import org.bridj.IntValuedEnum;
import org.bridj.Pointer;
import org.bridj.ann.Library;
import org.bridj.ann.Name;
import org.bridj.ann.Ptr;
import org.bridj.ann.Runtime;
import org.bridj.cpp.CPPRuntime;
import org.bridj.util.DefaultParameterizedType;
/**
 * Wrapper for library <b>raw</b><br>
 * This file was autogenerated by <a href="http://jnaerator.googlecode.com/">JNAerator</a>,<br>
 * a tool written by <a href="http://ochafik.com/">Olivier Chafik</a> that <a href="http://code.google.com/p/jnaerator/wiki/CreditsAndLicense">uses a few opensource projects.</a>.<br>
 * For help, please visit <a href="http://nativelibs4java.googlecode.com/">NativeLibs4Java</a> or <a href="http://bridj.googlecode.com/">BridJ</a> .
 */
@Library("raw") 
@Runtime(CPPRuntime.class) 
public class RawLibrary {
	static {
		BridJ.register();
	}
	/**
	 * -*- C++ -*-<br>
	 * File: libraw_const.h<br>
	 * Copyright 2008-2015 LibRaw LLC (info@libraw.org)<br>
	 * Created: Sat Mar  8 , 2008<br>
	 * LibRaw error codes<br>
	 * LibRaw is free software; you can redistribute it and/or modify<br>
	 * it under the terms of the one of three licenses as you choose:<br>
	 * 1. GNU LESSER GENERAL PUBLIC LICENSE version 2.1<br>
	 * (See file LICENSE.LGPL provided in LibRaw distribution archive for details).<br>
	 * 2. COMMON DEVELOPMENT AND DISTRIBUTION LICENSE (CDDL) Version 1.0<br>
	 * (See file LICENSE.CDDL provided in LibRaw distribution archive for details).<br>
	 * 3. LibRaw Software License 27032010<br>
	 * (See file LICENSE.LibRaw.pdf provided in LibRaw distribution archive for details).<br>
	 * enum values<br>
	 * <i>native declaration : libraw_const.h:26</i>
	 */
	public enum LibRaw_colormatrix_type implements IntValuedEnum<LibRaw_colormatrix_type > {
		LIBRAW_CMATRIX_NONE(0),
		LIBRAW_CMATRIX_DNG(1),
		LIBRAW_CMATRIX_DIGBACK(2),
		LIBRAW_CMATRIX_OTHER(4);
		LibRaw_colormatrix_type(long value) {
			this.value = value;
		}
		public final long value;
		public long value() {
			return this.value;
		}
		public Iterator<LibRaw_colormatrix_type > iterator() {
			return Collections.singleton(this).iterator();
		}
		public static IntValuedEnum<LibRaw_colormatrix_type > fromValue(int value) {
			return FlagSet.fromValue(value, values());
		}
	};
	/**
	 * enum values<br>
	 * <i>native declaration : libraw_const.h:34</i>
	 */
	public enum LibRaw_camera_mounts implements IntValuedEnum<LibRaw_camera_mounts > {
		LIBRAW_MOUNT_Unknown(0),
		LIBRAW_MOUNT_Minolta_A(1),
		LIBRAW_MOUNT_Sony_E(2),
		LIBRAW_MOUNT_Canon_EF(3),
		LIBRAW_MOUNT_Canon_EF_S(4),
		LIBRAW_MOUNT_Canon_EF_M(5),
		LIBRAW_MOUNT_Nikon_F(6),
		/** used in Nikon 1 series */
		LIBRAW_MOUNT_Nikon_CX(7),
		/** original 4/3 */
		LIBRAW_MOUNT_FT(8),
		/** micro 4/3 */
		LIBRAW_MOUNT_mFT(9),
		LIBRAW_MOUNT_Pentax_K(10),
		LIBRAW_MOUNT_Pentax_Q(11),
		LIBRAW_MOUNT_Pentax_645(12),
		LIBRAW_MOUNT_Fuji_X(13),
		LIBRAW_MOUNT_Leica_M(14),
		LIBRAW_MOUNT_Leica_R(15),
		LIBRAW_MOUNT_Leica_S(16),
		LIBRAW_MOUNT_Samsung_NX(17),
		LIBRAW_MOUNT_RicohModule(18),
		LIBRAW_MOUNT_Samsung_NX_M(19),
		LIBRAW_MOUNT_Leica_T(20),
		LIBRAW_MOUNT_Contax_N(21),
		LIBRAW_MOUNT_Sigma_X3F(22),
		LIBRAW_MOUNT_FixedLens(99);
		LibRaw_camera_mounts(long value) {
			this.value = value;
		}
		public final long value;
		public long value() {
			return this.value;
		}
		public Iterator<LibRaw_camera_mounts > iterator() {
			return Collections.singleton(this).iterator();
		}
		public static IntValuedEnum<LibRaw_camera_mounts > fromValue(int value) {
			return FlagSet.fromValue(value, values());
		}
	};
	/**
	 * enum values<br>
	 * <i>native declaration : libraw_const.h:62</i>
	 */
	public enum LibRaw_camera_formats implements IntValuedEnum<LibRaw_camera_formats > {
		LIBRAW_FORMAT_APSC(1),
		LIBRAW_FORMAT_FF(2),
		LIBRAW_FORMAT_MF(3),
		LIBRAW_FORMAT_APSH(4),
		LIBRAW_FORMAT_FT(8);
		LibRaw_camera_formats(long value) {
			this.value = value;
		}
		public final long value;
		public long value() {
			return this.value;
		}
		public Iterator<LibRaw_camera_formats > iterator() {
			return Collections.singleton(this).iterator();
		}
		public static IntValuedEnum<LibRaw_camera_formats > fromValue(int value) {
			return FlagSet.fromValue(value, values());
		}
	};
	/**
	 * enum values<br>
	 * <i>native declaration : libraw_const.h:73</i>
	 */
	public enum LibRaw_sonyarw2_options implements IntValuedEnum<LibRaw_sonyarw2_options > {
		LIBRAW_SONYARW2_NONE(0),
		LIBRAW_SONYARW2_BASEONLY(1),
		LIBRAW_SONYARW2_DELTAONLY(2),
		LIBRAW_SONYARW2_DELTAZEROBASE(3),
		LIBRAW_SONYARW2_DELTATOVALUE(4);
		LibRaw_sonyarw2_options(long value) {
			this.value = value;
		}
		public final long value;
		public long value() {
			return this.value;
		}
		public Iterator<LibRaw_sonyarw2_options > iterator() {
			return Collections.singleton(this).iterator();
		}
		public static IntValuedEnum<LibRaw_sonyarw2_options > fromValue(int value) {
			return FlagSet.fromValue(value, values());
		}
	};
	/**
	 * enum values<br>
	 * <i>native declaration : libraw_const.h:81</i>
	 */
	public enum LibRaw_dp2q_options implements IntValuedEnum<LibRaw_dp2q_options > {
		LIBRAW_DP2QOPT_NONE(0),
		LIBRAW_DP2Q_INTERPOLATERG(1),
		LIBRAW_DP2Q_INTERPOLATEAF(2);
		LibRaw_dp2q_options(long value) {
			this.value = value;
		}
		public final long value;
		public long value() {
			return this.value;
		}
		public Iterator<LibRaw_dp2q_options > iterator() {
			return Collections.singleton(this).iterator();
		}
		public static IntValuedEnum<LibRaw_dp2q_options > fromValue(int value) {
			return FlagSet.fromValue(value, values());
		}
	};
	/**
	 * enum values<br>
	 * <i>native declaration : libraw_const.h:88</i>
	 */
	public enum LibRaw_decoder_flags implements IntValuedEnum<LibRaw_decoder_flags > {
		/** LIBRAW_DECODER_FLATFIELD = 1<<1, */
		LIBRAW_DECODER_USEBAYER2(1 << 3),
		LIBRAW_DECODER_HASCURVE(1 << 4),
		LIBRAW_DECODER_SONYARW2(1 << 5),
		LIBRAW_DECODER_TRYRAWSPEED(1 << 6),
		LIBRAW_DECODER_OWNALLOC(1 << 7),
		LIBRAW_DECODER_FIXEDMAXC(1 << 8),
		LIBRAW_DECODER_NOTSET(1 << 15);
		LibRaw_decoder_flags(long value) {
			this.value = value;
		}
		public final long value;
		public long value() {
			return this.value;
		}
		public Iterator<LibRaw_decoder_flags > iterator() {
			return Collections.singleton(this).iterator();
		}
		public static IntValuedEnum<LibRaw_decoder_flags > fromValue(int value) {
			return FlagSet.fromValue(value, values());
		}
	};
	/**
	 * enum values<br>
	 * <i>native declaration : libraw_const.h:103</i>
	 */
	public enum LibRaw_constructor_flags implements IntValuedEnum<LibRaw_constructor_flags > {
		LIBRAW_OPTIONS_NONE(0),
		LIBRAW_OPIONS_NO_MEMERR_CALLBACK(1),
		LIBRAW_OPIONS_NO_DATAERR_CALLBACK(1 << 1);
		LibRaw_constructor_flags(long value) {
			this.value = value;
		}
		public final long value;
		public long value() {
			return this.value;
		}
		public Iterator<LibRaw_constructor_flags > iterator() {
			return Collections.singleton(this).iterator();
		}
		public static IntValuedEnum<LibRaw_constructor_flags > fromValue(int value) {
			return FlagSet.fromValue(value, values());
		}
	};
	/**
	 * enum values<br>
	 * <i>native declaration : libraw_const.h:110</i>
	 */
	public enum LibRaw_warnings implements IntValuedEnum<LibRaw_warnings > {
		LIBRAW_WARN_NONE(0),
		LIBRAW_WARN_FOVEON_NOMATRIX(1),
		LIBRAW_WARN_FOVEON_INVALIDWB(1 << 1),
		LIBRAW_WARN_BAD_CAMERA_WB(1 << 2),
		LIBRAW_WARN_NO_METADATA(1 << 3),
		LIBRAW_WARN_NO_JPEGLIB(1 << 4),
		LIBRAW_WARN_NO_EMBEDDED_PROFILE(1 << 5),
		LIBRAW_WARN_NO_INPUT_PROFILE(1 << 6),
		LIBRAW_WARN_BAD_OUTPUT_PROFILE(1 << 7),
		LIBRAW_WARN_NO_BADPIXELMAP(1 << 8),
		LIBRAW_WARN_BAD_DARKFRAME_FILE(1 << 9),
		LIBRAW_WARN_BAD_DARKFRAME_DIM(1 << 10),
		LIBRAW_WARN_NO_JASPER(1 << 11),
		LIBRAW_WARN_RAWSPEED_PROBLEM(1 << 12),
		LIBRAW_WARN_RAWSPEED_UNSUPPORTED(1 << 13),
		LIBRAW_WARN_RAWSPEED_PROCESSED(1 << 14),
		LIBRAW_WARN_FALLBACK_TO_AHD(1 << 15);
		LibRaw_warnings(long value) {
			this.value = value;
		}
		public final long value;
		public long value() {
			return this.value;
		}
		public Iterator<LibRaw_warnings > iterator() {
			return Collections.singleton(this).iterator();
		}
		public static IntValuedEnum<LibRaw_warnings > fromValue(int value) {
			return FlagSet.fromValue(value, values());
		}
	};
	/**
	 * enum values<br>
	 * <i>native declaration : libraw_const.h:131</i>
	 */
	public enum LibRaw_exceptions implements IntValuedEnum<LibRaw_exceptions > {
		LIBRAW_EXCEPTION_NONE(0),
		LIBRAW_EXCEPTION_ALLOC(1),
		LIBRAW_EXCEPTION_DECODE_RAW(2),
		LIBRAW_EXCEPTION_DECODE_JPEG(3),
		LIBRAW_EXCEPTION_IO_EOF(4),
		LIBRAW_EXCEPTION_IO_CORRUPT(5),
		LIBRAW_EXCEPTION_CANCELLED_BY_CALLBACK(6),
		LIBRAW_EXCEPTION_BAD_CROP(7),
		LIBRAW_EXCEPTION_IO_BADFILE(8),
		LIBRAW_EXCEPTION_DECODE_JPEG2000(9);
		LibRaw_exceptions(long value) {
			this.value = value;
		}
		public final long value;
		public long value() {
			return this.value;
		}
		public Iterator<LibRaw_exceptions > iterator() {
			return Collections.singleton(this).iterator();
		}
		public static IntValuedEnum<LibRaw_exceptions > fromValue(int value) {
			return FlagSet.fromValue(value, values());
		}
	};
	/**
	 * enum values<br>
	 * <i>native declaration : libraw_const.h:159</i>
	 */
	public enum LibRaw_progress implements IntValuedEnum<LibRaw_progress > {
		LIBRAW_PROGRESS_START(0),
		LIBRAW_PROGRESS_OPEN(1),
		LIBRAW_PROGRESS_IDENTIFY(1 << 1),
		LIBRAW_PROGRESS_SIZE_ADJUST(1 << 2),
		LIBRAW_PROGRESS_LOAD_RAW(1 << 3),
		LIBRAW_PROGRESS_RAW2_IMAGE(1 << 4),
		LIBRAW_PROGRESS_REMOVE_ZEROES(1 << 5),
		LIBRAW_PROGRESS_BAD_PIXELS(1 << 6),
		LIBRAW_PROGRESS_DARK_FRAME(1 << 7),
		LIBRAW_PROGRESS_FOVEON_INTERPOLATE(1 << 8),
		LIBRAW_PROGRESS_SCALE_COLORS(1 << 9),
		LIBRAW_PROGRESS_PRE_INTERPOLATE(1 << 10),
		LIBRAW_PROGRESS_INTERPOLATE(1 << 11),
		LIBRAW_PROGRESS_MIX_GREEN(1 << 12),
		LIBRAW_PROGRESS_MEDIAN_FILTER(1 << 13),
		LIBRAW_PROGRESS_HIGHLIGHTS(1 << 14),
		LIBRAW_PROGRESS_FUJI_ROTATE(1 << 15),
		LIBRAW_PROGRESS_FLIP(1 << 16),
		LIBRAW_PROGRESS_APPLY_PROFILE(1 << 17),
		LIBRAW_PROGRESS_CONVERT_RGB(1 << 18),
		LIBRAW_PROGRESS_STRETCH(1 << 19),
		/** reserved */
		LIBRAW_PROGRESS_STAGE20(1 << 20),
		LIBRAW_PROGRESS_STAGE21(1 << 21),
		LIBRAW_PROGRESS_STAGE22(1 << 22),
		LIBRAW_PROGRESS_STAGE23(1 << 23),
		LIBRAW_PROGRESS_STAGE24(1 << 24),
		LIBRAW_PROGRESS_STAGE25(1 << 25),
		LIBRAW_PROGRESS_STAGE26(1 << 26),
		LIBRAW_PROGRESS_STAGE27(1 << 27),
		LIBRAW_PROGRESS_THUMB_LOAD(1 << 28),
		LIBRAW_PROGRESS_TRESERVED1(1 << 29),
		LIBRAW_PROGRESS_TRESERVED2(1 << 30),
		LIBRAW_PROGRESS_TRESERVED3(1 << 31);
		LibRaw_progress(long value) {
			this.value = value;
		}
		public final long value;
		public long value() {
			return this.value;
		}
		public Iterator<LibRaw_progress > iterator() {
			return Collections.singleton(this).iterator();
		}
		public static IntValuedEnum<LibRaw_progress > fromValue(int value) {
			return FlagSet.fromValue(value, values());
		}
	};
	/**
	 * enum values<br>
	 * <i>native declaration : libraw_const.h:199</i>
	 */
	public enum LibRaw_errors implements IntValuedEnum<LibRaw_errors > {
		LIBRAW_SUCCESS(0),
		LIBRAW_UNSPECIFIED_ERROR(-1),
		LIBRAW_FILE_UNSUPPORTED(-2),
		LIBRAW_REQUEST_FOR_NONEXISTENT_IMAGE(-3),
		LIBRAW_OUT_OF_ORDER_CALL(-4),
		LIBRAW_NO_THUMBNAIL(-5),
		LIBRAW_UNSUPPORTED_THUMBNAIL(-6),
		LIBRAW_INPUT_CLOSED(-7),
		LIBRAW_UNSUFFICIENT_MEMORY(-100007),
		LIBRAW_DATA_ERROR(-100008),
		LIBRAW_IO_ERROR(-100009),
		LIBRAW_CANCELLED_BY_CALLBACK(-100010),
		LIBRAW_BAD_CROP(-100011);
		LibRaw_errors(long value) {
			this.value = value;
		}
		public final long value;
		public long value() {
			return this.value;
		}
		public Iterator<LibRaw_errors > iterator() {
			return Collections.singleton(this).iterator();
		}
		public static IntValuedEnum<LibRaw_errors > fromValue(int value) {
			return FlagSet.fromValue(value, values());
		}
	};
	/**
	 * enum values<br>
	 * <i>native declaration : libraw_const.h:218</i>
	 */
	public enum LibRaw_thumbnail_formats implements IntValuedEnum<LibRaw_thumbnail_formats > {
		LIBRAW_THUMBNAIL_UNKNOWN(0),
		LIBRAW_THUMBNAIL_JPEG(1),
		LIBRAW_THUMBNAIL_BITMAP(2),
		LIBRAW_THUMBNAIL_LAYER(4),
		LIBRAW_THUMBNAIL_ROLLEI(5);
		LibRaw_thumbnail_formats(long value) {
			this.value = value;
		}
		public final long value;
		public long value() {
			return this.value;
		}
		public Iterator<LibRaw_thumbnail_formats > iterator() {
			return Collections.singleton(this).iterator();
		}
		public static IntValuedEnum<LibRaw_thumbnail_formats > fromValue(int value) {
			return FlagSet.fromValue(value, values());
		}
	};
	/**
	 * enum values<br>
	 * <i>native declaration : libraw_const.h:227</i>
	 */
	public enum LibRaw_image_formats implements IntValuedEnum<LibRaw_image_formats > {
		LIBRAW_IMAGE_JPEG(1),
		LIBRAW_IMAGE_BITMAP(2);
		LibRaw_image_formats(long value) {
			this.value = value;
		}
		public final long value;
		public long value() {
			return this.value;
		}
		public Iterator<LibRaw_image_formats > iterator() {
			return Collections.singleton(this).iterator();
		}
		public static IntValuedEnum<LibRaw_image_formats > fromValue(int value) {
			return FlagSet.fromValue(value, values());
		}
	};
	/** <i>native declaration : libraw.h</i> */
	public static final int LIBRAW_USE_STREAMS_DATASTREAM_MAXSIZE = (int)(250 * 1024 * 1024);
	/** <i>native declaration : libraw_const.h</i> */
	public static final double LIBRAW_DEFAULT_ADJUST_MAXIMUM_THRESHOLD = (double)0.75;
	/** <i>native declaration : libraw_const.h</i> */
	public static final double LIBRAW_DEFAULT_AUTO_BRIGHTNESS_THRESHOLD = (double)0.01;
	/** <i>native declaration : libraw_const.h</i> */
	public static final int LIBRAW_XTRANS = (int)9;
	/** <i>native declaration : libraw_const.h</i> */
	public static final int LIBRAW_PROGRESS_THUMB_MASK = (int)0x0fffffff;
	/** <i>native declaration : libraw_version.h</i> */
	public static final int LIBRAW_MAJOR_VERSION = (int)0;
	/** <i>native declaration : libraw_version.h</i> */
	public static final int LIBRAW_MINOR_VERSION = (int)17;
	/** <i>native declaration : libraw_version.h</i> */
	public static final int LIBRAW_PATCH_VERSION = (int)0;
	/** <i>native declaration : libraw_version.h</i> */
	public static final int LIBRAW_SHLIB_CURRENT = (int)15;
	/** <i>native declaration : libraw_version.h</i> */
	public static final int LIBRAW_SHLIB_REVISION = (int)0;
	/** <i>native declaration : libraw_version.h</i> */
	public static final int LIBRAW_SHLIB_AGE = (int)0;
	/** <i>native declaration : libraw_version.h</i> */
	public static final String LIBRAW_VERSION_STR = (String)"0";
	/** <i>native declaration : libraw_version.h</i> */
	public static final int LIBRAW_VERSION = (int)(((0) << 16) | ((17) << 8) | (0));
	/** <i>native declaration : libraw_internal.h</i> */
	public static final int LIBRAW_HISTOGRAM_SIZE = (int)0x2000;
	/** <i>native declaration : libraw_alloc.h</i> */
	public static final int LIBRAW_MSIZE = (int)32;
	/** <i>native declaration : libraw_types.h</i> */
	public static abstract class memory_callback extends Callback<memory_callback > {
		public void apply(Pointer<? > data, Pointer<Byte > file, Pointer<Byte > where) {
			apply(Pointer.getPeer(data), Pointer.getPeer(file), Pointer.getPeer(where));
		}
		public void apply(@Ptr long data, @Ptr long file, @Ptr long where) {
			apply(Pointer.pointerToAddress(data), (Pointer)Pointer.pointerToAddress(file, Byte.class), (Pointer)Pointer.pointerToAddress(where, Byte.class));
		}
	};
	/** <i>native declaration : libraw_types.h</i> */
	public static abstract class exif_parser_callback extends Callback<exif_parser_callback > {
		public void apply(Pointer<? > context, int tag, int type, int len, int ord, Pointer<? > ifp) {
			apply(Pointer.getPeer(context), tag, type, len, ord, Pointer.getPeer(ifp));
		}
		public void apply(@Ptr long context, int tag, int type, int len, int ord, @Ptr long ifp) {
			apply(Pointer.pointerToAddress(context), tag, type, len, ord, Pointer.pointerToAddress(ifp));
		}
	};
	/** <i>native declaration : libraw_types.h</i> */
	public static abstract class data_callback extends Callback<data_callback > {
		public void apply(Pointer<? > data, Pointer<Byte > file, int offset) {
			apply(Pointer.getPeer(data), Pointer.getPeer(file), offset);
		}
		public void apply(@Ptr long data, @Ptr long file, int offset) {
			apply(Pointer.pointerToAddress(data), (Pointer)Pointer.pointerToAddress(file, Byte.class), offset);
		}
	};
	/** <i>native declaration : libraw_types.h</i> */
	public static abstract class progress_callback extends Callback<progress_callback > {
		public int apply(Pointer<? > data, IntValuedEnum<RawLibrary.LibRaw_progress > stage, int iteration, int expected) {
			return apply(Pointer.getPeer(data), (int)stage.value(), iteration, expected);
		}
		public int apply(@Ptr long data, int stage, int iteration, int expected) {
			return apply(Pointer.pointerToAddress(data), FlagSet.fromValue(stage, RawLibrary.LibRaw_progress.class), iteration, expected);
		}
	};
	/**
	 * Original signature : <code>void default_memory_callback(void*, const char*, const char*)</code><br>
	 * <i>native declaration : libraw_types.h:93</i>
	 */
	@Name("default_memory_callback") 
	public static void defaultMemoryCallback(Pointer<? > data, Pointer<Byte > file, Pointer<Byte > where) {
		defaultMemoryCallback(Pointer.getPeer(data), Pointer.getPeer(file), Pointer.getPeer(where));
	}
	@Name("default_memory_callback") 
	protected native static void defaultMemoryCallback(@Ptr long data, @Ptr long file, @Ptr long where);
	/**
	 * Original signature : <code>void default_data_callback(void*, const char*, const int)</code><br>
	 * <i>native declaration : libraw_types.h:97</i>
	 */
	@Name("default_data_callback") 
	public static void defaultDataCallback(Pointer<? > data, Pointer<Byte > file, int offset) {
		defaultDataCallback(Pointer.getPeer(data), Pointer.getPeer(file), offset);
	}
	@Name("default_data_callback") 
	protected native static void defaultDataCallback(@Ptr long data, @Ptr long file, int offset);
	/**
	 * Original signature : <code>char* libraw_strerror(int)</code><br>
	 * <i>native declaration : libraw.h:46</i>
	 */
	@Name("libraw_strerror") 
	public static Pointer<Byte > librawStrerror(int errorcode) {
		return (Pointer)Pointer.pointerToAddress(librawStrerror$2(errorcode), Byte.class);
	}
	@Name("libraw_strerror") 
	@Ptr 
	protected native static long librawStrerror$2(int errorcode);
	/**
	 * Original signature : <code>char* libraw_strprogress(LibRaw_progress)</code><br>
	 * <i>native declaration : libraw.h:47</i>
	 */
	@Name("libraw_strprogress") 
	public static Pointer<Byte > librawStrprogress(IntValuedEnum<RawLibrary.LibRaw_progress > arg1) {
		return (Pointer)Pointer.pointerToAddress(librawStrprogress((int)arg1.value()), Byte.class);
	}
	@Name("libraw_strprogress") 
	@Ptr 
	protected native static long librawStrprogress(int arg1);
	/**
	 * Original signature : <code>libraw_data_t* libraw_init(unsigned int)</code><br>
	 * <i>native declaration : libraw.h:49</i>
	 */
	@Name("libraw_init") 
	public static Pointer<libraw_data_t > librawInit(int flags) {
		return (Pointer)Pointer.pointerToAddress(librawInit$2(flags), libraw_data_t.class);
	}
	@Name("libraw_init") 
	@Ptr 
	protected native static long librawInit$2(int flags);
	/**
	 * Original signature : <code>int libraw_open_file(libraw_data_t*, const char*)</code><br>
	 * <i>native declaration : libraw.h:50</i>
	 */
	@Name("libraw_open_file") 
	public static int librawOpenFile(Pointer<libraw_data_t > libraw_data_tPtr1, Pointer<Byte > charPtr1) {
		return librawOpenFile(Pointer.getPeer(libraw_data_tPtr1), Pointer.getPeer(charPtr1));
	}
	@Name("libraw_open_file") 
	protected native static int librawOpenFile(@Ptr long libraw_data_tPtr1, @Ptr long charPtr1);
	/**
	 * Original signature : <code>int libraw_open_file_ex(libraw_data_t*, const char*, INT64)</code><br>
	 * <i>native declaration : libraw.h:51</i>
	 */
	@Name("libraw_open_file_ex") 
	public static int librawOpenFileEx(Pointer<libraw_data_t > libraw_data_tPtr1, Pointer<Byte > charPtr1, long max_buff_sz) {
		return librawOpenFileEx(Pointer.getPeer(libraw_data_tPtr1), Pointer.getPeer(charPtr1), max_buff_sz);
	}
	@Name("libraw_open_file_ex") 
	protected native static int librawOpenFileEx(@Ptr long libraw_data_tPtr1, @Ptr long charPtr1, long max_buff_sz);
	/**
	 * Original signature : <code>int libraw_open_buffer(libraw_data_t*, void*, size_t)</code><br>
	 * <i>native declaration : libraw.h:56</i>
	 */
	@Name("libraw_open_buffer") 
	public static int librawOpenBuffer(Pointer<libraw_data_t > libraw_data_tPtr1, Pointer<? > buffer, @Ptr long size) {
		return librawOpenBuffer(Pointer.getPeer(libraw_data_tPtr1), Pointer.getPeer(buffer), size);
	}
	@Name("libraw_open_buffer") 
	protected native static int librawOpenBuffer(@Ptr long libraw_data_tPtr1, @Ptr long buffer, @Ptr long size);
	/**
	 * Original signature : <code>int libraw_unpack(libraw_data_t*)</code><br>
	 * <i>native declaration : libraw.h:57</i>
	 */
	@Name("libraw_unpack") 
	public static int librawUnpack(Pointer<libraw_data_t > libraw_data_tPtr1) {
		return librawUnpack(Pointer.getPeer(libraw_data_tPtr1));
	}
	@Name("libraw_unpack") 
	protected native static int librawUnpack(@Ptr long libraw_data_tPtr1);
	/**
	 * Original signature : <code>int libraw_unpack_thumb(libraw_data_t*)</code><br>
	 * <i>native declaration : libraw.h:58</i>
	 */
	@Name("libraw_unpack_thumb") 
	public static int librawUnpackThumb(Pointer<libraw_data_t > libraw_data_tPtr1) {
		return librawUnpackThumb(Pointer.getPeer(libraw_data_tPtr1));
	}
	@Name("libraw_unpack_thumb") 
	protected native static int librawUnpackThumb(@Ptr long libraw_data_tPtr1);
	/**
	 * Original signature : <code>void libraw_recycle_datastream(libraw_data_t*)</code><br>
	 * <i>native declaration : libraw.h:59</i>
	 */
	@Name("libraw_recycle_datastream") 
	public static void librawRecycleDatastream(Pointer<libraw_data_t > libraw_data_tPtr1) {
		librawRecycleDatastream(Pointer.getPeer(libraw_data_tPtr1));
	}
	@Name("libraw_recycle_datastream") 
	protected native static void librawRecycleDatastream(@Ptr long libraw_data_tPtr1);
	/**
	 * Original signature : <code>void libraw_recycle(libraw_data_t*)</code><br>
	 * <i>native declaration : libraw.h:60</i>
	 */
	@Name("libraw_recycle") 
	public static void librawRecycle(Pointer<libraw_data_t > libraw_data_tPtr1) {
		librawRecycle(Pointer.getPeer(libraw_data_tPtr1));
	}
	@Name("libraw_recycle") 
	protected native static void librawRecycle(@Ptr long libraw_data_tPtr1);
	/**
	 * Original signature : <code>void libraw_close(libraw_data_t*)</code><br>
	 * <i>native declaration : libraw.h:61</i>
	 */
	@Name("libraw_close") 
	public static void librawClose(Pointer<libraw_data_t > libraw_data_tPtr1) {
		librawClose(Pointer.getPeer(libraw_data_tPtr1));
	}
	@Name("libraw_close") 
	protected native static void librawClose(@Ptr long libraw_data_tPtr1);
	/**
	 * Original signature : <code>void libraw_subtract_black(libraw_data_t*)</code><br>
	 * <i>native declaration : libraw.h:62</i>
	 */
	@Name("libraw_subtract_black") 
	public static void librawSubtractBlack(Pointer<libraw_data_t > libraw_data_tPtr1) {
		librawSubtractBlack(Pointer.getPeer(libraw_data_tPtr1));
	}
	@Name("libraw_subtract_black") 
	protected native static void librawSubtractBlack(@Ptr long libraw_data_tPtr1);
	/**
	 * Original signature : <code>int libraw_raw2image(libraw_data_t*)</code><br>
	 * <i>native declaration : libraw.h:63</i>
	 */
	@Name("libraw_raw2image") 
	public static int librawRaw2image(Pointer<libraw_data_t > libraw_data_tPtr1) {
		return librawRaw2image(Pointer.getPeer(libraw_data_tPtr1));
	}
	@Name("libraw_raw2image") 
	protected native static int librawRaw2image(@Ptr long libraw_data_tPtr1);
	/**
	 * Original signature : <code>void libraw_free_image(libraw_data_t*)</code><br>
	 * <i>native declaration : libraw.h:64</i>
	 */
	@Name("libraw_free_image") 
	public static void librawFreeImage(Pointer<libraw_data_t > libraw_data_tPtr1) {
		librawFreeImage(Pointer.getPeer(libraw_data_tPtr1));
	}
	@Name("libraw_free_image") 
	protected native static void librawFreeImage(@Ptr long libraw_data_tPtr1);
	/**
	 * Original signature : <code>char* libraw_version()</code><br>
	 * <i>native declaration : libraw.h:66</i>
	 */
	@Name("libraw_version") 
	public static Pointer<Byte > librawVersion() {
		return (Pointer)Pointer.pointerToAddress(librawVersion$2(), Byte.class);
	}
	@Name("libraw_version") 
	@Ptr 
	protected native static long librawVersion$2();
	/**
	 * Original signature : <code>int libraw_versionNumber()</code><br>
	 * <i>native declaration : libraw.h:67</i>
	 */
	@Name("libraw_versionNumber") 
	public static native int librawVersionNumber();
	/**
	 * Original signature : <code>char** libraw_cameraList()</code><br>
	 * <i>native declaration : libraw.h:69</i>
	 */
	@Name("libraw_cameraList") 
	public static Pointer<Pointer<Byte > > librawCameraList() {
		return (Pointer)Pointer.pointerToAddress(librawCameraList$2(), DefaultParameterizedType.paramType(Pointer.class, Byte.class));
	}
	@Name("libraw_cameraList") 
	@Ptr 
	protected native static long librawCameraList$2();
	/**
	 * Original signature : <code>int libraw_cameraCount()</code><br>
	 * <i>native declaration : libraw.h:70</i>
	 */
	@Name("libraw_cameraCount") 
	public static native int librawCameraCount();
	/**
	 * Original signature : <code>void libraw_set_memerror_handler(libraw_data_t*, memory_callback, void*)</code><br>
	 * <i>native declaration : libraw.h:73</i>
	 */
	@Name("libraw_set_memerror_handler") 
	public static void librawSetMemerrorHandler(Pointer<libraw_data_t > libraw_data_tPtr1, Pointer<RawLibrary.memory_callback > cb, Pointer<? > datap) {
		librawSetMemerrorHandler(Pointer.getPeer(libraw_data_tPtr1), Pointer.getPeer(cb), Pointer.getPeer(datap));
	}
	@Name("libraw_set_memerror_handler") 
	protected native static void librawSetMemerrorHandler(@Ptr long libraw_data_tPtr1, @Ptr long cb, @Ptr long datap);
	/**
	 * Original signature : <code>void libraw_set_exifparser_handler(libraw_data_t*, exif_parser_callback, void*)</code><br>
	 * <i>native declaration : libraw.h:74</i>
	 */
	@Name("libraw_set_exifparser_handler") 
	public static void librawSetExifparserHandler(Pointer<libraw_data_t > libraw_data_tPtr1, Pointer<RawLibrary.exif_parser_callback > cb, Pointer<? > datap) {
		librawSetExifparserHandler(Pointer.getPeer(libraw_data_tPtr1), Pointer.getPeer(cb), Pointer.getPeer(datap));
	}
	@Name("libraw_set_exifparser_handler") 
	protected native static void librawSetExifparserHandler(@Ptr long libraw_data_tPtr1, @Ptr long cb, @Ptr long datap);
	/**
	 * Original signature : <code>void libraw_set_dataerror_handler(libraw_data_t*, data_callback, void*)</code><br>
	 * <i>native declaration : libraw.h:75</i>
	 */
	@Name("libraw_set_dataerror_handler") 
	public static void librawSetDataerrorHandler(Pointer<libraw_data_t > libraw_data_tPtr1, Pointer<RawLibrary.data_callback > func, Pointer<? > datap) {
		librawSetDataerrorHandler(Pointer.getPeer(libraw_data_tPtr1), Pointer.getPeer(func), Pointer.getPeer(datap));
	}
	@Name("libraw_set_dataerror_handler") 
	protected native static void librawSetDataerrorHandler(@Ptr long libraw_data_tPtr1, @Ptr long func, @Ptr long datap);
	/**
	 * Original signature : <code>void libraw_set_progress_handler(libraw_data_t*, progress_callback, void*)</code><br>
	 * <i>native declaration : libraw.h:76</i>
	 */
	@Name("libraw_set_progress_handler") 
	public static void librawSetProgressHandler(Pointer<libraw_data_t > libraw_data_tPtr1, Pointer<RawLibrary.progress_callback > cb, Pointer<? > datap) {
		librawSetProgressHandler(Pointer.getPeer(libraw_data_tPtr1), Pointer.getPeer(cb), Pointer.getPeer(datap));
	}
	@Name("libraw_set_progress_handler") 
	protected native static void librawSetProgressHandler(@Ptr long libraw_data_tPtr1, @Ptr long cb, @Ptr long datap);
	/**
	 * Original signature : <code>char* libraw_unpack_function_name(libraw_data_t*)</code><br>
	 * <i>native declaration : libraw.h:77</i>
	 */
	@Name("libraw_unpack_function_name") 
	public static Pointer<Byte > librawUnpackFunctionName(Pointer<libraw_data_t > lr) {
		return (Pointer)Pointer.pointerToAddress(librawUnpackFunctionName(Pointer.getPeer(lr)), Byte.class);
	}
	@Name("libraw_unpack_function_name") 
	@Ptr 
	protected native static long librawUnpackFunctionName(@Ptr long lr);
	/**
	 * Original signature : <code>int libraw_get_decoder_info(libraw_data_t*, libraw_decoder_info_t*)</code><br>
	 * <i>native declaration : libraw.h:78</i>
	 */
	@Name("libraw_get_decoder_info") 
	public static int librawGetDecoderInfo(Pointer<libraw_data_t > lr, Pointer<libraw_decoder_info_t > d) {
		return librawGetDecoderInfo(Pointer.getPeer(lr), Pointer.getPeer(d));
	}
	@Name("libraw_get_decoder_info") 
	protected native static int librawGetDecoderInfo(@Ptr long lr, @Ptr long d);
	/**
	 * Original signature : <code>int libraw_COLOR(libraw_data_t*, int, int)</code><br>
	 * <i>native declaration : libraw.h:79</i>
	 */
	@Name("libraw_COLOR") 
	public static int librawCOLOR(Pointer<libraw_data_t > libraw_data_tPtr1, int row, int col) {
		return librawCOLOR(Pointer.getPeer(libraw_data_tPtr1), row, col);
	}
	@Name("libraw_COLOR") 
	protected native static int librawCOLOR(@Ptr long libraw_data_tPtr1, int row, int col);
	/**
	 * Original signature : <code>int libraw_adjust_sizes_info_only(libraw_data_t*)</code><br>
	 * <i>native declaration : libraw.h:82</i>
	 */
	@Name("libraw_adjust_sizes_info_only") 
	public static int librawAdjustSizesInfoOnly(Pointer<libraw_data_t > libraw_data_tPtr1) {
		return librawAdjustSizesInfoOnly(Pointer.getPeer(libraw_data_tPtr1));
	}
	@Name("libraw_adjust_sizes_info_only") 
	protected native static int librawAdjustSizesInfoOnly(@Ptr long libraw_data_tPtr1);
	/**
	 * Original signature : <code>int libraw_dcraw_ppm_tiff_writer(libraw_data_t*, const char*)</code><br>
	 * <i>native declaration : libraw.h:83</i>
	 */
	@Name("libraw_dcraw_ppm_tiff_writer") 
	public static int librawDcrawPpmTiffWriter(Pointer<libraw_data_t > lr, Pointer<Byte > filename) {
		return librawDcrawPpmTiffWriter(Pointer.getPeer(lr), Pointer.getPeer(filename));
	}
	@Name("libraw_dcraw_ppm_tiff_writer") 
	protected native static int librawDcrawPpmTiffWriter(@Ptr long lr, @Ptr long filename);
	/**
	 * Original signature : <code>int libraw_dcraw_thumb_writer(libraw_data_t*, const char*)</code><br>
	 * <i>native declaration : libraw.h:84</i>
	 */
	@Name("libraw_dcraw_thumb_writer") 
	public static int librawDcrawThumbWriter(Pointer<libraw_data_t > lr, Pointer<Byte > fname) {
		return librawDcrawThumbWriter(Pointer.getPeer(lr), Pointer.getPeer(fname));
	}
	@Name("libraw_dcraw_thumb_writer") 
	protected native static int librawDcrawThumbWriter(@Ptr long lr, @Ptr long fname);
	/**
	 * Original signature : <code>int libraw_dcraw_process(libraw_data_t*)</code><br>
	 * <i>native declaration : libraw.h:85</i>
	 */
	@Name("libraw_dcraw_process") 
	public static int librawDcrawProcess(Pointer<libraw_data_t > lr) {
		return librawDcrawProcess(Pointer.getPeer(lr));
	}
	@Name("libraw_dcraw_process") 
	protected native static int librawDcrawProcess(@Ptr long lr);
	/**
	 * Original signature : <code>libraw_processed_image_t* libraw_dcraw_make_mem_image(libraw_data_t*, int*)</code><br>
	 * <i>native declaration : libraw.h:86</i>
	 */
	@Name("libraw_dcraw_make_mem_image") 
	public static Pointer<libraw_processed_image_t > librawDcrawMakeMemImage(Pointer<libraw_data_t > lr, Pointer<Integer > errc) {
		return (Pointer)Pointer.pointerToAddress(librawDcrawMakeMemImage(Pointer.getPeer(lr), Pointer.getPeer(errc)), libraw_processed_image_t.class);
	}
	@Name("libraw_dcraw_make_mem_image") 
	@Ptr 
	protected native static long librawDcrawMakeMemImage(@Ptr long lr, @Ptr long errc);
	/**
	 * Original signature : <code>libraw_processed_image_t* libraw_dcraw_make_mem_thumb(libraw_data_t*, int*)</code><br>
	 * <i>native declaration : libraw.h:87</i>
	 */
	@Name("libraw_dcraw_make_mem_thumb") 
	public static Pointer<libraw_processed_image_t > librawDcrawMakeMemThumb(Pointer<libraw_data_t > lr, Pointer<Integer > errc) {
		return (Pointer)Pointer.pointerToAddress(librawDcrawMakeMemThumb(Pointer.getPeer(lr), Pointer.getPeer(errc)), libraw_processed_image_t.class);
	}
	@Name("libraw_dcraw_make_mem_thumb") 
	@Ptr 
	protected native static long librawDcrawMakeMemThumb(@Ptr long lr, @Ptr long errc);
	/**
	 * Original signature : <code>void libraw_dcraw_clear_mem(libraw_processed_image_t*)</code><br>
	 * <i>native declaration : libraw.h:88</i>
	 */
	@Name("libraw_dcraw_clear_mem") 
	public static void librawDcrawClearMem(Pointer<libraw_processed_image_t > libraw_processed_image_tPtr1) {
		librawDcrawClearMem(Pointer.getPeer(libraw_processed_image_tPtr1));
	}
	@Name("libraw_dcraw_clear_mem") 
	protected native static void librawDcrawClearMem(@Ptr long libraw_processed_image_tPtr1);
	/**
	 * Original signature : <code>void libraw_set_demosaic(libraw_data_t*, int)</code><br>
	 * <i>native declaration : libraw.h:90</i>
	 */
	@Name("libraw_set_demosaic") 
	public static void librawSetDemosaic(Pointer<libraw_data_t > lr, int value) {
		librawSetDemosaic(Pointer.getPeer(lr), value);
	}
	@Name("libraw_set_demosaic") 
	protected native static void librawSetDemosaic(@Ptr long lr, int value);
	/**
	 * Original signature : <code>void libraw_set_output_color(libraw_data_t*, int)</code><br>
	 * <i>native declaration : libraw.h:91</i>
	 */
	@Name("libraw_set_output_color") 
	public static void librawSetOutputColor(Pointer<libraw_data_t > lr, int value) {
		librawSetOutputColor(Pointer.getPeer(lr), value);
	}
	@Name("libraw_set_output_color") 
	protected native static void librawSetOutputColor(@Ptr long lr, int value);
	/**
	 * Original signature : <code>void libraw_set_output_bps(libraw_data_t*, int)</code><br>
	 * <i>native declaration : libraw.h:92</i>
	 */
	@Name("libraw_set_output_bps") 
	public static void librawSetOutputBps(Pointer<libraw_data_t > lr, int value) {
		librawSetOutputBps(Pointer.getPeer(lr), value);
	}
	@Name("libraw_set_output_bps") 
	protected native static void librawSetOutputBps(@Ptr long lr, int value);
	/**
	 * Original signature : <code>void libraw_set_gamma(libraw_data_t*, int, float)</code><br>
	 * <i>native declaration : libraw.h:93</i>
	 */
	@Name("libraw_set_gamma") 
	public static void librawSetGamma(Pointer<libraw_data_t > lr, int index, float value) {
		librawSetGamma(Pointer.getPeer(lr), index, value);
	}
	@Name("libraw_set_gamma") 
	protected native static void librawSetGamma(@Ptr long lr, int index, float value);
	/**
	 * Original signature : <code>void libraw_set_no_auto_bright(libraw_data_t*, int)</code><br>
	 * <i>native declaration : libraw.h:94</i>
	 */
	@Name("libraw_set_no_auto_bright") 
	public static void librawSetNoAutoBright(Pointer<libraw_data_t > lr, int value) {
		librawSetNoAutoBright(Pointer.getPeer(lr), value);
	}
	@Name("libraw_set_no_auto_bright") 
	protected native static void librawSetNoAutoBright(@Ptr long lr, int value);
	/**
	 * Original signature : <code>void libraw_set_bright(libraw_data_t*, float)</code><br>
	 * <i>native declaration : libraw.h:95</i>
	 */
	@Name("libraw_set_bright") 
	public static void librawSetBright(Pointer<libraw_data_t > lr, float value) {
		librawSetBright(Pointer.getPeer(lr), value);
	}
	@Name("libraw_set_bright") 
	protected native static void librawSetBright(@Ptr long lr, float value);
	/**
	 * Original signature : <code>void libraw_set_highlight(libraw_data_t*, int)</code><br>
	 * <i>native declaration : libraw.h:96</i>
	 */
	@Name("libraw_set_highlight") 
	public static void librawSetHighlight(Pointer<libraw_data_t > lr, int value) {
		librawSetHighlight(Pointer.getPeer(lr), value);
	}
	@Name("libraw_set_highlight") 
	protected native static void librawSetHighlight(@Ptr long lr, int value);
	/**
	 * Original signature : <code>void libraw_set_fbdd_noiserd(libraw_data_t*, int)</code><br>
	 * <i>native declaration : libraw.h:97</i>
	 */
	@Name("libraw_set_fbdd_noiserd") 
	public static void librawSetFbddNoiserd(Pointer<libraw_data_t > lr, int value) {
		librawSetFbddNoiserd(Pointer.getPeer(lr), value);
	}
	@Name("libraw_set_fbdd_noiserd") 
	protected native static void librawSetFbddNoiserd(@Ptr long lr, int value);
	/**
	 * Original signature : <code>int libraw_get_raw_height(libraw_data_t*)</code><br>
	 * <i>native declaration : libraw.h:98</i>
	 */
	@Name("libraw_get_raw_height") 
	public static int librawGetRawHeight(Pointer<libraw_data_t > lr) {
		return librawGetRawHeight(Pointer.getPeer(lr));
	}
	@Name("libraw_get_raw_height") 
	protected native static int librawGetRawHeight(@Ptr long lr);
	/**
	 * Original signature : <code>int libraw_get_raw_width(libraw_data_t*)</code><br>
	 * <i>native declaration : libraw.h:99</i>
	 */
	@Name("libraw_get_raw_width") 
	public static int librawGetRawWidth(Pointer<libraw_data_t > lr) {
		return librawGetRawWidth(Pointer.getPeer(lr));
	}
	@Name("libraw_get_raw_width") 
	protected native static int librawGetRawWidth(@Ptr long lr);
	/**
	 * Original signature : <code>int libraw_get_iheight(libraw_data_t*)</code><br>
	 * <i>native declaration : libraw.h:100</i>
	 */
	@Name("libraw_get_iheight") 
	public static int librawGetIheight(Pointer<libraw_data_t > lr) {
		return librawGetIheight(Pointer.getPeer(lr));
	}
	@Name("libraw_get_iheight") 
	protected native static int librawGetIheight(@Ptr long lr);
	/**
	 * Original signature : <code>int libraw_get_iwidth(libraw_data_t*)</code><br>
	 * <i>native declaration : libraw.h:101</i>
	 */
	@Name("libraw_get_iwidth") 
	public static int librawGetIwidth(Pointer<libraw_data_t > lr) {
		return librawGetIwidth(Pointer.getPeer(lr));
	}
	@Name("libraw_get_iwidth") 
	protected native static int librawGetIwidth(@Ptr long lr);
	/**
	 * Original signature : <code>float libraw_get_cam_mul(libraw_data_t*, int)</code><br>
	 * <i>native declaration : libraw.h:102</i>
	 */
	@Name("libraw_get_cam_mul") 
	public static float librawGetCamMul(Pointer<libraw_data_t > lr, int index) {
		return librawGetCamMul(Pointer.getPeer(lr), index);
	}
	@Name("libraw_get_cam_mul") 
	protected native static float librawGetCamMul(@Ptr long lr, int index);
	/**
	 * Original signature : <code>float libraw_get_pre_mul(libraw_data_t*, int)</code><br>
	 * <i>native declaration : libraw.h:103</i>
	 */
	@Name("libraw_get_pre_mul") 
	public static float librawGetPreMul(Pointer<libraw_data_t > lr, int index) {
		return librawGetPreMul(Pointer.getPeer(lr), index);
	}
	@Name("libraw_get_pre_mul") 
	protected native static float librawGetPreMul(@Ptr long lr, int index);
	/**
	 * Original signature : <code>float libraw_get_rgb_cam(libraw_data_t*, int, int)</code><br>
	 * <i>native declaration : libraw.h:104</i>
	 */
	@Name("libraw_get_rgb_cam") 
	public static float librawGetRgbCam(Pointer<libraw_data_t > lr, int index1, int index2) {
		return librawGetRgbCam(Pointer.getPeer(lr), index1, index2);
	}
	@Name("libraw_get_rgb_cam") 
	protected native static float librawGetRgbCam(@Ptr long lr, int index1, int index2);
	/**
	 * Original signature : <code>int libraw_get_color_maximum(libraw_data_t*)</code><br>
	 * <i>native declaration : libraw.h:105</i>
	 */
	@Name("libraw_get_color_maximum") 
	public static int librawGetColorMaximum(Pointer<libraw_data_t > lr) {
		return librawGetColorMaximum(Pointer.getPeer(lr));
	}
	@Name("libraw_get_color_maximum") 
	protected native static int librawGetColorMaximum(@Ptr long lr);
	/** Undefined type */
	public static interface LibRaw_abstract_datastream {
		
	};
}
